import { _type } from "./symbols";
import { isValid, makeValit } from "./utils";
export function guard(...[name, guardFn, handleOptions, defaultOptions]) {
    return makeValit(name, (fn) => {
        const validateFn = ((value, options, path, parent) => {
            const res = fn(value, options, path, parent);
            if (isValid(res))
                return {
                    valid: true,
                    data: res,
                    errors: [],
                };
            return {
                valid: false,
                data: undefined,
                errors: [
                    {
                        message: `vality.${name}.base`,
                        path,
                        options,
                        value,
                    },
                ],
            };
        });
        validateFn[_type] = fn[_type];
        return validateFn;
    }, handleOptions, defaultOptions)(guardFn);
}
//# sourceMappingURL=guard.js.map